]> git.proxmox.com Git - rustc.git/blob - src/ci/run.sh
Update upstream source from tag 'upstream/1.62.1+dfsg1'
[rustc.git] / src / ci / run.sh
1 #!/usr/bin/env bash
2
3 set -e
4
5 if [ -n "$CI_JOB_NAME" ]; then
6 echo "[CI_JOB_NAME=$CI_JOB_NAME]"
7 fi
8
9 if [ "$NO_CHANGE_USER" = "" ]; then
10 if [ "$LOCAL_USER_ID" != "" ]; then
11 useradd --shell /bin/bash -u $LOCAL_USER_ID -o -c "" -m user
12 export HOME=/home/user
13 unset LOCAL_USER_ID
14 exec su --preserve-environment -c "env PATH=$PATH \"$0\"" user
15 fi
16 fi
17
18 # only enable core dump on Linux
19 if [ -f /proc/sys/kernel/core_pattern ]; then
20 ulimit -c unlimited
21 fi
22
23 # There was a bad interaction between "old" 32-bit binaries on current 64-bit
24 # kernels with selinux enabled, where ASLR mmap would sometimes choose a low
25 # address and then block it for being below `vm.mmap_min_addr` -> `EACCES`.
26 # This is probably a kernel bug, but setting `ulimit -Hs` works around it.
27 # See also `dist-i686-linux` where this setting is enabled.
28 if [ "$SET_HARD_RLIMIT_STACK" = "1" ]; then
29 rlimit_stack=$(ulimit -Ss)
30 if [ "$rlimit_stack" != "" ]; then
31 ulimit -Hs "$rlimit_stack"
32 fi
33 fi
34
35 ci_dir=`cd $(dirname $0) && pwd`
36 source "$ci_dir/shared.sh"
37
38 if command -v python > /dev/null; then
39 PYTHON="python"
40 elif command -v python3 > /dev/null; then
41 PYTHON="python3"
42 else
43 PYTHON="python2"
44 fi
45
46 if ! isCI || isCiBranch auto || isCiBranch beta || isCiBranch try; then
47 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --set build.print-step-timings --enable-verbose-tests"
48 fi
49
50 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-sccache"
51 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --disable-manage-submodules"
52 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-locked-deps"
53 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-cargo-native-static"
54 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --set rust.codegen-units-std=1"
55
56 # Only produce xz tarballs on CI. gz tarballs will be generated by the release
57 # process by recompressing the existing xz ones. This decreases the storage
58 # space required for CI artifacts.
59 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --dist-compression-formats=xz"
60
61 if [ "$DIST_SRC" = "" ]; then
62 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --disable-dist-src"
63 fi
64
65 # Always set the release channel for bootstrap; this is normally not important (i.e., only dist
66 # builds would seem to matter) but in practice bootstrap wants to know whether we're targeting
67 # master, beta, or stable with a build to determine whether to run some checks (notably toolstate).
68 export RUST_RELEASE_CHANNEL=$(releaseChannel)
69 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --release-channel=$RUST_RELEASE_CHANNEL"
70
71 if [ "$DEPLOY$DEPLOY_ALT" = "1" ]; then
72 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-llvm-static-stdcpp"
73 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --set rust.remap-debuginfo"
74 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --debuginfo-level-std=1"
75
76 if [ "$NO_LLVM_ASSERTIONS" = "1" ]; then
77 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --disable-llvm-assertions"
78 elif [ "$DEPLOY_ALT" != "" ]; then
79 if [ "$NO_PARALLEL_COMPILER" = "" ]; then
80 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --set rust.parallel-compiler"
81 fi
82 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-llvm-assertions"
83 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --set rust.verify-llvm-ir"
84 fi
85 else
86 # We almost always want debug assertions enabled, but sometimes this takes too
87 # long for too little benefit, so we just turn them off.
88 if [ "$NO_DEBUG_ASSERTIONS" = "" ]; then
89 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-debug-assertions"
90 fi
91
92 # Same for overflow checks
93 if [ "$NO_OVERFLOW_CHECKS" = "" ]; then
94 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-overflow-checks"
95 fi
96
97 # In general we always want to run tests with LLVM assertions enabled, but not
98 # all platforms currently support that, so we have an option to disable.
99 if [ "$NO_LLVM_ASSERTIONS" = "" ]; then
100 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-llvm-assertions"
101 fi
102
103 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --set rust.verify-llvm-ir"
104 fi
105
106 if [ "$RUST_RELEASE_CHANNEL" = "nightly" ] || [ "$DIST_REQUIRE_ALL_TOOLS" = "" ]; then
107 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-missing-tools"
108 fi
109
110 export COMPILETEST_NEEDS_ALL_LLVM_COMPONENTS=1
111
112 # Print the date from the local machine and the date from an external source to
113 # check for clock drifts. An HTTP URL is used instead of HTTPS since on Azure
114 # Pipelines it happened that the certificates were marked as expired.
115 datecheck() {
116 echo "== clock drift check =="
117 echo -n " local time: "
118 date
119 echo -n " network time: "
120 curl -fs --head http://ci-caches.rust-lang.org | grep ^Date: \
121 | sed 's/Date: //g' || true
122 echo "== end clock drift check =="
123 }
124 datecheck
125 trap datecheck EXIT
126
127 # We've had problems in the past of shell scripts leaking fds into the sccache
128 # server (#48192) which causes Cargo to erroneously think that a build script
129 # hasn't finished yet. Try to solve that problem by starting a very long-lived
130 # sccache server at the start of the build, but no need to worry if this fails.
131 SCCACHE_IDLE_TIMEOUT=10800 sccache --start-server || true
132
133 if [ "$RUN_CHECK_WITH_PARALLEL_QUERIES" != "" ]; then
134 $SRC/configure --enable-parallel-compiler
135 CARGO_INCREMENTAL=0 $PYTHON ../x.py check
136 rm -f config.toml
137 rm -rf build
138 fi
139
140 $SRC/configure $RUST_CONFIGURE_ARGS
141
142 retry make prepare
143
144 # Display the CPU and memory information. This helps us know why the CI timing
145 # is fluctuating.
146 if isMacOS; then
147 system_profiler SPHardwareDataType || true
148 sysctl hw || true
149 ncpus=$(sysctl -n hw.ncpu)
150 else
151 cat /proc/cpuinfo || true
152 cat /proc/meminfo || true
153 ncpus=$(grep processor /proc/cpuinfo | wc -l)
154 fi
155
156 if [ ! -z "$SCRIPT" ]; then
157 sh -x -c "$SCRIPT"
158 else
159 do_make() {
160 echo "make -j $ncpus $1"
161 make -j $ncpus $1
162 local retval=$?
163 return $retval
164 }
165
166 do_make "$RUST_CHECK_TARGET"
167 fi
168
169 sccache --show-stats || true